#ifndef CAMSENSOR_SP0A19_YCBCR_H
#define CAMSENSOR_SP0A19_YCBCR_H
/*============================================================================

                 Camera Interface Device Driver Header File for 
                    Galaxycore SP0A19_YCBCR VGA CMOS sensor

   DESCRIPTION
     This file contains the definitions needed for the camera interface
     device driver.

============================================================================*/

/*============================================================================

                      EDIT HISTORY FOR FILE

 This section contains comments describing changes made to this file.
 Notice that changes are listed in reverse chronological order.

 when      who    what, where, why
 --------  -----  ----------------------------------------------------------
 2010-9-2      Initial release.

============================================================================*/

/*============================================================================
                        INCLUDE FILES
============================================================================*/

#include "camsensor.h"
#include "camctrl.h"

/*============================================================================
                        CONSTANT DEFINITIONS
============================================================================*/

/*============================================================================
                          EXPORTED FUNCTIONS
============================================================================*/

/*===========================================================================

FUNCTION      CAMSENSOR_SP0A19_YCBCR_INIT

DESCRIPTION
              Initialize the camera sensor;

DEPENDENCIES
  None

RETURN VALUE
  if successful
    TRUE
  else
    FALSE

SIDE EFFECTS
  None

===========================================================================*/
boolean camsensor_sp0A19_init (camsensor_function_table_type *camsensor_function_table_ptr,
                                     camctrl_tbl_type              *camctrl_tbl_ptr);

#endif /* CAMSENSOR_SP0A19_YCBCR_H */

