/****************************************************************
*  COPYRIGHT Leadcore Technology Co.,Ltd     *
*****************************************************************/
/*****************************************************************
 * FileName:    sensor_SP0A19_c.h
 *
 * Version:     
 *
 * Purpose:      
 *
 * Authors:      
 *
 * Notes:       
 ******************************************************************/
 /*****************************************************************
 *                      HISTORY
 *-----------------------------------------------------------------
 *    when        who        where,what,why
 *-----------------------------------------------------------------
 * 2011.06.08    victor zhou     Create.
 ******************************************************************/
 
#ifndef __SENSOR_SP0A19_C_H__
#define __SENSOR_SP0A19_C_H__

//-------------------------------------------------------------------------------------------------------
//      SP0A19 registers setting parameters.
//-------------------------------------------------------------------------------------------------------

#define SP0A19_ONE_DATA_LENGTH                 2

#define SP0A19_PID_REG	0x02
#define SP0A19_PID_VAL	0xA6
//HEQ
#define  SP0A19_P0_0xdd  0x80
#define  SP0A19_P0_0xde  0xa8/*brightness*/

#define SP0A19_SET_BRIGHTNESS(x,y,z) \
	icSP0A19Brightness[0][1]=(x);\
	icSP0A19Brightness[1][1]=(y);\	
	icSP0A19Brightness[2][1]=(z)	
/*contrast*/
#define SP0A19_SET_CONTRAST(x,y,z,i) \
	icSP0A19Contrast[0][1]=(x);\
	icSP0A19Contrast[1][1]=(y);\	
	icSP0A19Contrast[2][1]=(z);\
	icSP0A19Contrast[3][1]=(i)
/*effect*/
#define SP0A19_SET_EFFECT(a,b,c,d,e) \
        icSP0A19Effect[0][1]=(a);\
        icSP0A19Effect[1][1]=(b);\
        icSP0A19Effect[2][1]=(c);\
        icSP0A19Effect[3][1]=(d);\
        icSP0A19Effect[4][1]=(e)

/******************************************************************************
*  Private Data Declare
******************************************************************************/

/*sensor control pin :power down */
static GPIO_ID gPinPwdn = GPIO_ID_MAX;
/*sensor control pin :reset */
static GPIO_ID gPinReset = GPIO_ID_MAX;

//-------------------------------------------------------------------------------------------------------
//      Initial code
//-------------------------------------------------------------------------------------------------------
// Sensor initial
static const unsigned char icSP0A19Init[][SP0A19_ONE_DATA_LENGTH] = 
{
  {0x1C,0x28},//00
  {0x32,0x00}, 
  {0x0f,0x2f},// 3f//p1
  {0x10,0x2e},// 3a//p2
  {0x11,0x00},//p3
  {0x12,0x18},// 3f//p4
  {0x13,0x2f},// 3f//p5
  {0x14,0x00},// 2//p6
  {0x15,0x3f},// 3f//p7
  {0x16,0x00},// 02//p8
  {0x17,0x18},// 3f//p9
  {0x25,0x40},// 3f//p10
  {0x1a,0x0b},// c
  {0x1b,0xc},
  {0x1e,0xb},
  {0x20,0x3f},
  {0x21,0x13},// 2f
  {0x22,0x19},// 13//10
  {0x26,0x1a},//02
  {0x27,0xab},// a3
  {0x28,0xfd},// 02
  {0x30,0x00}, 
  {0xfb,0x31},// 33
  {0x1f,0x08},// 10
  
//Blacklevel
  {0xfd,0x00},
  {0x65,0x00},//0x06 blue_suboffset
  {0x66,0x00},//0x06 red_suboffset
  {0x67,0x00},//0x06 gr_suboffset
  {0x68,0x00},//0x06 gb_suboffset
  {0x45,0x00},
  {0x46,0x0f},
  
//ae setting 26.6M 8-20fps   
  {0xfd,0x00},
  {0x03,0x01},
  {0x04,0x32},
  {0x06,0x00},
  {0x09,0x01},
  {0x0a,0xc6},
  {0xf0,0x66},
  {0xf1,0x00},
  {0xfd,0x01},
  {0x90,0x0c}, 
  {0x92,0x01},
  {0x98,0x66},
  {0x99,0x00},
  {0x9a,0x01},
  {0x9b,0x00},
//Status
  {0xfd,0x01},
  {0xce,0xc8},
  {0xcf,0x04},
  {0xd0,0xc8},
  {0xd1,0x04},
   
  {0xfd,0x01},
  {0xc4,0x56},//70
  {0xc5,0x8f},//74
  {0xca,0x30},
  {0xcb,0x45},
  {0xcc,0x70},//rpc_heq_low
  {0xcd,0x48},//rpc_heq_dummy
  {0xfd,0x00},
  
//lsc  for st
  {0xfd,0x01},
  {0x35,0x15},//18//14
  {0x36,0x15},// 1a//30 
  {0x37,0x15},// 15//22
  {0x38,0x15},//15//10
  {0x39,0x15},//15//10
  {0x3a,0x15},//15//25 
  {0x3b,0x13},//15//15
  {0x3c,0x15},//15//10
  {0x3d,0x15},//15//0d
  {0x3e,0x15},//13//22 
  {0x3f,0x15},//15//1a
  {0x40,0x18},// 1a//10
  {0x41,0x00},//06//15
  {0x42,0x04},//0b//2b
  {0x43,0x04},//0a//00
  {0x44,0x00},//08//18
  {0x45,0x00},//00//15
  {0x46,0x00},//fe//20
  {0x47,0x00},//00//00
  {0x48,0x00},//00//18
  {0x49,0xfd},//00//11
  {0x4a,0x00},//00//1c
  {0x4b,0x00},//00//00
  {0x4c,0xfd},//fd//12
  {0xfd,0x00},
 
  
//awb 1
  {0xfd,0x01},
  {0x28,0xc5},
  {0x29,0x9b},
//  0x10,0x08
//  0x11,0x14	
//  0x12,0x14
  {0x2e,0x02},	
  {0x2f,0x16},
  {0x17,0x17},
  {0x18,0x19},//29	
  {0x19,0x45},	

//  0x1a,0x9e//a1//a5	  
//  0x1b,0xae//b0//9a
//  0x33,0xef
  {0x2a,0xef},
  {0x2b,0x15},
  	
  //awb2
  {0xfd,0x01},
  {0x73,0x80},
  {0x1a,0x80},
  {0x1b,0x80 },
//d65
  {0x65,0xd5},//d6
  {0x66,0xfa},//f0
  {0x67,0x72},//7a
  {0x68,0x8a},//9a
//indoor
  {0x69,0xc6},//ab
  {0x6a,0xee},//ca
  {0x6b,0x94},//a3
  {0x6c,0xab}, //c1
//f
  {0x61,0x7a},//82
  {0x62,0x98},//a5
  {0x63,0xc5},//d6
  {0x64,0xe6},//ec
//cwf
 {0x6d,0xb9},//a5
 {0x6e,0xde},//c2
 {0x6f,0xb2},//a7
 {0x70,0xd5},//c5
 
//////////////////skin detect//////
 {0xfd,0x01},//
 {0x08,0x15},//
 {0x09,0x04},//
 {0x0a,0x20},//
 {0x0b,0x12},//
 {0x0c,0x27},//
 {0x0d,0x06},//
 {0x0f,0x63},//


  
//BPC_grad
  {0xfd,0x00},
  {0x79,0xf0},
  {0x7a,0x80},  //f0
  {0x7b,0x80},  //f0
  {0x7c,0x20},    //f0
  
//smooth
  {0xfd,0x00},
	//ͨƽֵ	
  {0x57,0x06},	//raw_dif_thr_outdoor
  {0x58,0x0d}, //raw_dif_thr_normal
  {0x56,0x10}, //raw_dif_thr_dummy
  {0x59,0x10}, //raw_dif_thr_lowlight
	//GrGbƽֵ
  {0x89,0x06},	//raw_grgb_thr_outdoor 
  {0x8a,0x0d}, //raw_grgb_thr_normal  
  {0x9c,0x10}, //raw_grgb_thr_dummy   
  {0x9d,0x10}, //raw_grgb_thr_lowlight

	//Gr\Gb֮ƽǿ
  {0x81,0xe0},    //raw_gflt_fac_outdoor
  {0x82,0xe0}, //80//raw_gflt_fac_normal
  {0x83,0x80},   //raw_gflt_fac_dummy
  {0x84,0x40},   //raw_gflt_fac_lowlight
	//GrGbͨƽǿ  
  {0x85,0xe0}, //raw_gf_fac_outdoor  
  {0x86,0xc0}, //raw_gf_fac_normal  
  {0x87,0x80}, //raw_gf_fac_dummy   
  {0x88,0x40}, //raw_gf_fac_lowlight
	//RBƽǿ  
  {0x5a,0xff},		 //raw_rb_fac_outdoor
  {0x5b,0xe0}, //40//raw_rb_fac_normal
  {0x5c,0x80}, 	 //raw_rb_fac_dummy
  {0x5d,0x00}, 	 //raw_rb_fac_lowlight
  
//sharpen 
  {0xfd,0x01},
  {0xe2,0x30},	//sharpen_y_base
  {0xe4,0xa0},	//sharpen_y_max
  
  {0xe5,0x04}, //rangek_neg_outdoor
  {0xd3,0x04}, //rangek_pos_outdoor   
  {0xd7,0x04}, //range_base_outdoor   
  
  {0xe6,0x04}, //rangek_neg_normal
  {0xd4,0x04}, //rangek_pos_normal 
  {0xd8,0x04}, //range_base_normal  
    
  {0xe7,0x08}, //rangek_neg_dummy
  {0xd5,0x08}, //rangek_pos_dummy
  {0xd9,0x08}, //range_base_dummy 
  	
  {0xd2,0x10}, //rangek_neg_lowlight
  {0xd6,0x10}, //rangek_pos_lowlight
  {0xda,0x10}, //range_base_lowlight

  {0xe8,0x20},//sharp_fac_pos_outdoor
  {0xec,0x35},//sharp_fac_neg_outdoor
  {0xe9,0x20},//sharp_fac_pos_nr
  {0xed,0x35},//sharp_fac_neg_nr
  {0xea,0x20},//sharp_fac_pos_dummy
  {0xef,0x30},//sharp_fac_neg_dummy
  {0xeb,0x10},//sharp_fac_pos_low
  {0xf0,0x20},//sharp_fac_neg_low 
  
//CCM
  {0xfd,0x01},
  {0xa0,0x80},//80(ɫӽɫ)
  {0xa1,0x00},//0 
  {0xa2,0x00}, //0 
  {0xa3,0xf3},//f0
  {0xa4,0x8e},//a6
  {0xa5,0x00}, //ea
  {0xa6,0x00}, //0 
  {0xa7,0xe6},//e6
  {0xa8,0x9a},//9a
  {0xa9,0x00}, //0 
  {0xaa,0x3}, //33
  {0xab,0xc}, //c 
  {0xfd,0x00},
  
//gamma  
  
 {0xfd,0x00},
 {0x8b,0x00}, //0 
 {0x8c,0xc}, //11
 {0x8d,0x19},//19 
 {0x8e,0x2c},//28 
 {0x8f,0x49},//46 
 {0x90,0x61},//61 
 {0x91,0x77},//78 
 {0x92,0x8a},//8A 
 {0x93,0x9b},//9B 
 {0x94,0xa9},//A9 
 {0x95,0xb5},//B5 
 {0x96,0xc0},//C0 
 {0x97,0xca},//CA 
 {0x98,0xd4},//D4 
 {0x99,0xdd},//DD 
 {0x9a,0xe6},//E6 
 {0x9b,0xef},//EF 
 {0xfd,0x01},//01 
 {0x8d,0xf7},//F7 
 {0x8e,0xff},//FF 
  	
//rpc
  {0xfd,0x00},
  {0xe0,0x4c},//48//4c//44//4c//3e//3c//3a//38//rpc_1base_max
  {0xe1,0x3c},//38//3c//36//3c//30//2e//2c//2a//rpc_2base_max
  {0xe2,0x34},//30//34//2e//34//2a//28//26//26//rpc_3base_max
  {0xe3,0x2e},// 2c/2e//2a//2e//26//24//22//rpc_4base_max   
  {0xe4,0x2e},// 2c//2e//2a//2e//26//24//22//rpc_5base_max
  {0xe5,0x2c},// 2a//2c//28//2c//24//22//20//rpc_6base_max
  {0xe6,0x2c},// 2a//2c//28//2c//24//22//20//rpc_7base_max
  {0xe8,0x2a},//28//2a//26//2a//22//20//20//1e//rpc_8base_max
  {0xe9,0x2a},//28//2a//26//2a//22//20//20//1e//rpc_9base_max
  {0xea,0x2a},//28//2a//26//2a//22//20//20//1e//rpc_10base_max
  {0xeb,0x28},//26//28//24//28//20//1f//1e//1d//rpc_11base_max
  {0xf5,0x28},//26//28//24//28//20//1f//1e//1d//rpc_12base_max
  {0xf6,0x28},//26//28//24//28//20//1f//1e//1d//rpc_13base_max
//ae min gain  
  {0xfd,0x01},
  {0x94,0xa0},//rpc_max_indr
  {0x95,0x28},// 1e//rpc_min_indr 
  {0x9c,0xa0},//rpc_max_outdr
  {0x9d,0x28},//rpc_min_outdr    

//ae target
  {0xfd,0x00}, 
  {0xed,0x8c},//80 
  {0xf7,0x88},//7c 
  {0xf8,0x80},//70 
  {0xec,0x7c},//6c  

  {0xef,0x74},//99
  {0xf9,0x70},//90
  {0xfa,0x68},//80
  {0xee,0x64},//78

    
//gray detect
  {0xfd,0x01},
  {0x30,0x40},
  {0x31,0x70},//
  {0x32,0x40},//80
  {0x33,0xef},//
  {0x34,0x05},//04
  {0x4d,0x2f},//40
  {0x4e,0x20},//
  {0x4f,0x16},//13         
  	
//lowlight lum
  {0xfd,0x00},
  {0xb2,0x20},//lum_limit
  {0xb3,0x1f},//lum_set
  {0xb4,0x30},//black_vt
  {0xb5,0x45},//white_vt

//saturation
  {0xfd,0x00},
  {0xbe,0xff},
  {0xbf,0x01}, 
  {0xc0,0xff},
  {0xc1,0xd8},
  {0xd3,0x88},//0x78
  {0xd4,0x88},//0x78
  {0xd6,0x80},//0x78      
  {0xd7,0x60},//0x78

//HEQ
  {0xfd,0x00},
  {0xdc,0x00},
  {0xdd,SP0A19_P0_0xdd},
  {0xde,SP0A19_P0_0xde},//80
  {0xdf,0x80}, 
  	
//func enable
  {0xfd,0x00},
  {0x31,0x00},
  {0x32,0x15},//d
  {0x34,0x76},// 16
  {0x33,0xef},
  {0x5f,0x51},
};
static const unsigned char icSP0A19Qqvga[][SP0A19_ONE_DATA_LENGTH] = 
{	
//QVGA resize QQVGA  zouyu 20120926
		{0xfd , 0x00},
		{0x48 , 0x78},
		{0x49 , 0x00},
		{0x4a , 0xf0},
		{0x4c , 0xa0},
		{0x4d , 0x01},
		{0x4e , 0x40},

		{0xfd , 0x01},   
		{0x0e , 0x03},  

		{0xfd , 0x00},
		{0x30 , 0x10},

};
static const unsigned char icSP0A19Qcif[][SP0A19_ONE_DATA_LENGTH] = 
{
 //whl120604 352 288---resizeto 176*144  //ok
	//352X288Begin 
	
	#if 1
	{0xfd , 0x00},
	{0x48 , 0x60},  // 0xb0(error)  zouyu 20120926
	
	{0x49 , 0x01},
	{0x4a , 0x20}, 
	
	{0x4c , 0x90},
	
	{0x4d , 0x01}, 
	{0x4e , 0x60},
  
	{0xfd , 0x01},   //whl120602
	{0x0e , 0x03},   //whl120602
	
	{0xfd , 0x00},
	{0x30 , 0x10},        //whl120602
	
	#endif
};

static const unsigned char icSP0A19Qvga[][SP0A19_ONE_DATA_LENGTH] = 
{
#if 1   //zouyu 20120926 VGA resize QVGA   
	//QVGA Begin 
	{0xfd , 0x00},
	{0x48 , 0x00},
	
	{0x49 , 0x01},
	{0x4a , 0xe0},
	
	{0x4c , 0x00},
	
	{0x4d , 0x02},
	{0x4e , 0x80},
	
	{0xfd , 0x01},   
	{0x0e , 0x03},   
	
	{0xfd , 0x00},	
	{0x30 , 0x10},	
	//QVGA End 
#endif

};

static const unsigned char icSP0A19Vga[][SP0A19_ONE_DATA_LENGTH] = 
{
#if 1
	//VGA Begin 
	
	{0xfd , 0x01},   //whl120602
	{0x0e , 0x00},    //whl120602

	{0xfd , 0x00},

	{0x48 , 0x00},
	
	{0x49 , 0x01},
	{0x4a , 0xe0},
	
	{0x4c , 0x00},
	
	{0x4d , 0x02},
	{0x4e , 0x80},

	{0x30 , 0x00},	   //whl120602
	//VGA End 
#endif
};

static unsigned char SP0A19_nightmodeenable[][SP0A19_ONE_DATA_LENGTH] = 
{
#if 1   //  50hz  26.6m 6-20
		//ae setting 26.6M 6-20fps   
  {0xfd,0x00},
  {0x03,0x01},
  {0x04,0x32},
  {0x06,0x00},
  {0x09,0x01},
  {0x0a,0xc6},
  {0xf0,0x66},
  {0xf1,0x00},
  {0xfd,0x01},
  {0x90,0x10}, 
  {0x92,0x01},
  {0x98,0x66},
  {0x99,0x00},
  {0x9a,0x01},
  {0x9b,0x00},
//Status
  {0xfd,0x01},
  {0xce,0x60},
  {0xcf,0x06},
  {0xd0,0x60},
  {0xd1,0x06},
  {0xfd,0x00},
  {0xb2,0x25},//lum_limit  nightmodeenable
  {0xb3,0x1f},//lum_set  
  {0xfd,0x00},
#endif

};

static unsigned char SP0A19_nightmodedisable[][SP0A19_ONE_DATA_LENGTH] = 
{
#if 1   //  50hz  26.6m 8-20
		//ae setting 26.6M 8-20fps     
  {0xfd,0x00},
  {0x03,0x01},
  {0x04,0x32}, 
  {0x06,0x00},
  {0x09,0x01},
  {0x0a,0xc6},
  {0xf0,0x66},
  {0xf1,0x00},
  {0xfd,0x01},   
  {0x90,0x0c}, 
  {0x92,0x01},
  {0x98,0x66},
  {0x99,0x00},
  {0x9a,0x01},
  {0x9b,0x00},
//Status
  {0xfd,0x01},
  {0xce,0xc8},
  {0xcf,0x04},
  {0xd0,0xc8},
  {0xd1,0x04},  
  {0xfd,0x00},
  {0xb2,0x20},//lum_limit  nightmodedisable
  {0xb3,0x1f},//lum_set  
  {0xfd,0x00},
#endif
};
/*brightness*/
static unsigned char icSP0A19Brightness[][SP0A19_ONE_DATA_LENGTH] = 
{
	{0xfd, 0x00},
	{0xdc, 0x00},	
	{0xff,0xff},
};

/*contrast*/
static unsigned char icSP0A19Contrast[][SP0A19_ONE_DATA_LENGTH] = 
{
	{0xfd, 0x00},
	{0xdd, SP0A19_P0_0xdd},	//level 0
	{0xde, SP0A19_P0_0xde},
	{0xff, 0xff}
};

/*effect*/
static unsigned char icSP0A19Effect[][SP0A19_ONE_DATA_LENGTH] = 
{
	{0xfd, 0x00},
	{0x62, 0x00},
	{0x63, 0x80},
	{0x64, 0x80},
	{0xff, 0xff}  
};

//-------------------------------------------------------------------------------------------------------
//     Format Informations
//-------------------------------------------------------------------------------------------------------

// Video Formats supported of sensor.
static const CAM_ENUM_CF cCamVideoFormatSupported[] = 
{
    CAM_CF_YUV422,  /* YUV422 */
};

// Still Formats supported of sensor.
static const CAM_ENUM_CF cCamStillFormatSupported[] = 
{
    CAM_CF_YUV422,  /* YUV422 */
};

static const CAM_FORMAT_SUPPORTED_DATA cCamFormatSupported[CAM_CST_UNDEFINED] = 
{
    {CAM_VIDEO_FORMAT_SUPPORTED_NUM, CAM_VIDEO_FORMAT_SUPPORTED_DATA},
    {CAM_STILL_FORMAT_SUPPORTED_NUM, CAM_STILL_FORMAT_SUPPORTED_DATA},
};


//-------------------------------------------------------------------------------------------------------
//     Resolution Informations
//-------------------------------------------------------------------------------------------------------
// Video resolutions supported of sensor.
static const CAM_ENUM_CR cCamVideoResolutionSupported[] = 
{
    CAM_CR_VGA,  /* VGA  */
    CAM_CR_QVGA, /* QVGA */
    CAM_CR_QCIF, /* QCIF */
    CAM_CR_QQVGA,/* QQVGA */
};

// Still resolutions supported of sensor.
static const CAM_ENUM_CR cCamStillResolutionSupported[] = 
{
    CAM_CR_SXGA,  /* SVGA */
    CAM_CR_VGA,  /* VGA */
    CAM_CR_QVGA, /* QVGA */
    CAM_CR_QCIF, /* QCIF */
};

// Resolution supported information.
static const CAM_RESOLUTION_SUPPORTED_DATA cCamResolutionSupported[CAM_CST_UNDEFINED] = 
{
        {CAM_VIDEO_RESOLUTION_SUPPORTED_NUM, CAM_VIDEO_RESOLUTION_SUPPORTED_DATA},
        {CAM_STILL_RESOLUTION_SUPPORTED_NUM, CAM_STILL_RESOLUTION_SUPPORTED_DATA},
};


//-------------------------------------------------------------------------------------------------------
//     Internal Functions Declaration
//-------------------------------------------------------------------------------------------------------
static int SP0A19_init(GPIO_ID pinPwdn, GPIO_ID pinReset);
static int SP0A19_deinit(void);
static int SP0A19_set_state(SENSOR_STATE eState);
static int SP0A19_set_format(CAM_ENUM_CST eStreamType, CAM_ENUM_CF eFormat);
static int SP0A19_set_resolution(CAM_ENUM_CST eStreamType, CAM_ENUM_CR eResolution);
static int SP0A19_start_stream(CAM_ENUM_CST eStreamType);
static int SP0A19_stop_stream(CAM_ENUM_CST eStreamType);
static int SP0A19_set_brightness(int nValue, BOOL bAuto);
static int  SP0A19_set_nightmode (int nValue, BOOL bAuto);  //whl120602 add 
static int SP0A19_set_contrast(int nValue, BOOL bAuto);
static int SP0A19_set_effect(int nValue, BOOL bAuto);
static int SP0A19_set_quality(int nValue, BOOL bAuto);
static PCAM_FORMAT_SUPPORTED_DATA SP0A19_get_format_supported(CAM_ENUM_CST eStreamType);
static PCAM_RESOLUTION_SUPPORTED_DATA SP0A19_get_resolution_supported(CAM_ENUM_CST eStreamType);
static int SP0A19_existence_detect(GPIO_ID pinPwdn, GPIO_ID pinReset);

//-------------------------------------------------------------------------------------------------------
//     sensor information and operation set
//-------------------------------------------------------------------------------------------------------
const SENSOR_OP cSensorOpTab_SENSOR_GALAXYCORE_SP0A19 = 
{
        {
            SENSOR_GALAXYCORE_SP0A19,        /* Sensor ID. */
            0x21,                            /* I2C slave address. */
            0xfd,                            /* Sensor page address. */
            "GALAXYCORE",                    /* Sensor factory name. */
            "SP0A19",                        /* Sensor name. */
            640,                             /* Maximum width. */
            480,                             /* Maximum height. */
		    1,                               /* nVideoDiscardFrames. */
            2,                               /* nStillDiscardFrames. */
            ANGLE_0,                        /* Sensor Direction */
            SENSOR_MCLK_21666K,
 	        {FALSE, 0},				         /*sJpegDataCaptureCfg*/
        },
        {
            SP0A19_init,                     /* Sensor Initial. */
            SP0A19_deinit,                   /* Sensor Deinitial. */
            SP0A19_set_state,                /* Set State. */                      
            SP0A19_set_format,               /* Set Ouput Format. */
            SP0A19_set_resolution,           /* Set Resolution. */
            SP0A19_start_stream,             /* Start Stream. */
            SP0A19_stop_stream,              /* Stop Stream. */
	    	NULL,							 /* GetJpegDataLen()	Get jpeg data len only in this sensor output jpeg data*/
			NULL,							 /* GetImageSizeInJpegCapture() */
			NULL,							 /* MakeJpeg() make stand jpeg based on jpeg data from sensor */
			SP0A19_get_format_supported,	 /* GetFormatSupported() */
			SP0A19_get_resolution_supported, /* GetResolutionSupported() */
			SP0A19_existence_detect,		 /*ExistenceDetect()*/
	        NULL,                            /* Set White Balance. */
            SP0A19_set_brightness,           /* Set Brightness. */
            SP0A19_set_contrast,             /* Set Contrast. */
            NULL,                            /* Set Sharpness. */
            NULL,                            /* Set Saturation. */
            NULL,                            /* Set Hue. */
            SP0A19_set_effect,               /* Set Effect. */
            NULL,                            /* Set Envi. */
            NULL,                            /* Set Zoom. */
            NULL,                             /* Set Flash. */            
            NULL,
            NULL,
            NULL,
            NULL,
            SP0A19_set_quality,
            SP0A19_set_nightmode   
        }

};
#endif/*__SENSOR_SP0A19_C_H__*/

